VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "RGBPick sample from BlackBeltVB.com"
   ClientHeight    =   2010
   ClientLeft      =   1635
   ClientTop       =   1545
   ClientWidth     =   5835
   Height          =   2415
   Left            =   1575
   LinkTopic       =   "Form1"
   ScaleHeight     =   2010
   ScaleWidth      =   5835
   Top             =   1200
   Width           =   5955
   Begin VB.PictureBox Picture1 
      Height          =   555
      Left            =   60
      ScaleHeight     =   495
      ScaleWidth      =   5655
      TabIndex        =   1
      Top             =   600
      Width           =   5715
   End
   Begin VB.Label lblHTML 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   3660
      TabIndex        =   7
      Top             =   1500
      Width           =   1635
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "HTML RGB (Foreground)"
      Height          =   195
      Index           =   3
      Left            =   3480
      TabIndex        =   6
      Top             =   1260
      Width           =   1995
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Foreground"
      Height          =   195
      Index           =   2
      Left            =   1980
      TabIndex        =   5
      Top             =   1260
      Width           =   975
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Background"
      Height          =   195
      Index           =   1
      Left            =   360
      TabIndex        =   4
      Top             =   1260
      Width           =   975
   End
   Begin VB.Label lblFG 
      BorderStyle     =   1  'Fixed Single
      Height          =   435
      Left            =   2100
      TabIndex        =   3
      Top             =   1500
      Width           =   735
   End
   Begin VB.Label lblBG 
      BorderStyle     =   1  'Fixed Single
      Height          =   435
      Left            =   480
      TabIndex        =   2
      Top             =   1500
      Width           =   735
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Left-click on a color to select the ""foreground"" color. Right-click to select the ""background"" color."
      Height          =   435
      Index           =   0
      Left            =   1020
      TabIndex        =   0
      Top             =   60
      Width           =   3675
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' RGBPick sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/rgbpick.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' It is impossible to display EVERY RGB color, as there are
' over 16 million colors. It would require a PictureBox 4096x4096
' pixels - larger than any screen. This procedure displays over
' 300 colors, only a fraction of the actual number possible.
'
' You must be running in > 256 colors to use this sample
' properly.
'
' Added the display for HTML RGB colors 8-5-99.

Private Type RGBType
    R As Byte
    G As Byte
    B As Byte
    Filler As Byte
End Type
Private Type RGBLongType
    clr As Long
End Type

Function ColorToHTML(clr As Long) As String
    Dim R As RGBType, RL As RGBLongType
    RL.clr = clr
    LSet R = RL
    Dim aR As String, aG As String, aB As String
    With R
        aR = Trim$(Hex$(.R)): If Len(aR) = 1 Then aR = "0" & aR
        aG = Trim$(Hex$(.G)): If Len(aG) = 1 Then aG = "0" & aG
        aB = Trim$(Hex$(.B)): If Len(aB) = 1 Then aB = "0" & aB
    End With
    ColorToHTML = aR & aG & aB
End Function

Private Sub Form_Load()
    Show
    With Picture1
        Dim X As Long, R As Integer, G As Integer, B As Integer, C As Long
        Dim rAdd As Integer, gAdd As Integer, bAdd As Integer
        rAdd = 5: gAdd = 0: bAdd = 0
        .AutoRedraw = True
        For X = 0 To .ScaleWidth Step Screen.TwipsPerPixelX
            Picture1.Line (X, 0)-(X, .ScaleHeight), C
            If R = 255 And G = 255 And B = 255 Then
                .Width = X + (.Width - .ScaleWidth)
                .Left = (ScaleWidth - .Width) \ 2
                Exit Sub
            End If
            R = R + rAdd
            If R > 255 Then
                rAdd = 0
                R = 255
                gAdd = 5
            ElseIf R < 0 Then
                rAdd = 0
                R = 0
                bAdd = 5
            End If
            G = G + gAdd
            If G > 255 Then
                gAdd = 0
                G = 255
                rAdd = -5
            ElseIf G < 0 Then
                gAdd = 0
                G = 0
                rAdd = 5
            End If
            B = B + bAdd
            If B > 255 Then
                bAdd = 0
                B = 255
                gAdd = -5
            End If
            C = RGB(R, G, B)
        Next
    End With
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then
        lblFG.BackColor = Picture1.Point(X, Y)
        lblHTML.Caption = ColorToHTML(lblFG.BackColor)
    ElseIf Button = vbRightButton Then
        lblBG.BackColor = Picture1.Point(X, Y)
    End If
End Sub
